/*
  cadaverserver
  Copyright (C) 1999  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __CONN_HPP
#define __CONN_HPP

#include "spielfeld.hpp"

#include <netinet/in.h>
#include <string>
#include <map>

class conn {
public:
  conn (const conn &);
  conn & operator= (const conn &);
  ~conn();
  conn(int handle_,struct sockaddr_in addr_);

  string outputbuffer;
  inline int id() const { return myid; };
  inline int gethandle() const { return handle; };

  bool manageinput ();
  bool manageoutput ();
  void displaystatistic();

  bool bossmode, lastsex;

private:
  void QN();

  int stat_sentbytes, stat_recvbytes;
  int handle, myid;
  struct sockaddr_in addr;
  string inputline;

  spielfeld oldfeld;
  tempmatrix <bool> visimap;
};

class connections {
public:
  connections();
  connections (const connections &);
  connections & operator= (const connections &);
  ~connections ();

  void add (conn *const newconn); // i now own the conn object
  void del (const int id);

  // you get direct access to the map but please do not use it.
  map<const int, conn *const> all;
};


extern connections *gcon;

#endif
