/*
  cadaverserver
  Copyright (C) 1999  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "fatal.hpp"

#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <errno.h>

void fatal (const char *const msg)
{
  fprintf(stderr,"\n\nFatal error\n%s\n\nProgram terminated,"
	  "trying to dump core\n\n", msg);
  raise (SIGSEGV);
};

void fatal_errno (const char *const msg)
{
  fprintf(stderr,"\n\nFatal error\n%s\nerrno: %s\n\nProgram terminated,"
	  "trying to dump core\n\n", msg,strerror(errno));
  raise (SIGSEGV);
};

