/*
  panzer
  Copyright (C) 1999  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __SELECTOR_HPP
#define __SELECTOR_HPP

#include "zeit.hpp"

#include <sys/types.h>

class selector {
public:
  selector ();
  selector (const selector &);
  selector & operator= (const selector &);

  void reset(); // clears read and write lists and sets timeout to infinity
  void add_read(const int handle);
  void add_write(const int handle);
  void settimeout(const zeit & timeout_); // timeout is relative to the time of call of waitnow()
  void waitnow ();
  bool isready_read(const int handle);
  bool isready_write(const int handle);
  inline bool istimeoutexpired() { return timeout_expired; };

private:
  fd_set readfds, writefds;
  bool infinity;
  zeit timeout;
  bool timeout_expired;
};



#endif
