/*
  cadaverserver
  Copyright (C) 1999  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __SPIELFELD_HPP
#define __SPIELFELD_HPP

#include "tempmatrix.hpp"

class feld {
public:
  feld ();

  // WATER==-1.0 means field invisible
  enum floatvalue_type { WATER=0, GRAIN=1, GRASS=2, CARCASS=3, HAY=4, MEAT=5, BREAD=6, FOREST=7 };
  static inline int floatvalue_count () { return 8; };
  static const char *const floatvalue_textdescription (const floatvalue_type number);

  inline float &get_float (const floatvalue_type type) { return floatvalue[type]; };

  void dump (char *buf) const;
  void load (const char *buf);

private:
  float floatvalue[8];
};

typedef tempmatrix<feld> spielfeld;

#endif
