/*
  cadaverserver
  Copyright (C) 1999  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __TEMPMATRIX_HPP
#define __TEMPMATRIX_HPP

template <class X>
class tempmatrix {
public:
  tempmatrix (const tempmatrix &);
  tempmatrix & operator= (const tempmatrix &);
  ~tempmatrix ();
  tempmatrix (const int xs_, const int ys_);

  inline int xsize () const { return xs; };
  inline int ysize () const { return ys; };
  inline const X &get (const int x, const int y) const { return matrix[x+y*xs]; };
  inline X &get (const int x, const int y) { return matrix[x+y*xs]; };

private:
  int xs, ys;
  X *matrix;
};

template <class X>
tempmatrix<X>::~tempmatrix ()
{
  delete [] matrix;
};

template <class X>
tempmatrix<X>::tempmatrix (const int xs_, const int ys_)
  : xs(xs_), ys(ys_), matrix(new X [xs_*ys_])
{
};

#endif
