/*
  panzer
  Copyright (C) 1999  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __ZEIT_HPP
#define __ZEIT_HPP

#include "binarydefs.hpp"

#include <time.h>

class zeit {
  friend const bool operator< (const zeit &a, const zeit &b);
public:
  zeit (); // setzt zeit auf 0
  zeit (const int32 seconds);
  zeit (const int32 seconds, const int32 microseconds);

  void getcurrenttime (); // set me to current system time
  void add (const zeit &other);
  void subtract (const zeit &other);
  void normalize ();
  float tofloat() const;
  bool isnegative() const; // 0 is not negative.

  void convert_to_timeval (struct timeval & tv) const;

private:
  int32 s, us;
};

const bool operator< (const zeit &a, const zeit &b);

#endif
